import pysftp
import class_ia_configure

class init():
    
    def __init__(self, host, uid, pwd):
        self.host = host
        self.uid = uid
        self.pwd = pwd
        #self.cnopts = pysftp.CnOpts(knownhosts='known_hosts')
        self.cnopts = pysftp.CnOpts()
        self.cnopts.hostkeys = None
        iaCfgFilePath = './ia.ini'
        self.clsCFG = class_ia_configure.init(iaCfgFilePath)        

    # purpose: to get the files from sftp server
    def get_files(self, remote_file_path, local_file_path):
        #print('ftp file path===>', remote_file_path, local_file_path)
        with pysftp.Connection(self.host, username=self.uid, password=self.pwd, cnopts=self.cnopts) as sftp_handle:
            #print('get the ftp handler!!!')
            if sftp_handle.exists(remote_file_path):
                #print('file exists...')
                sftp_handle.get(remote_file_path, local_file_path)
                #print('ftp success download!')
            else:
                self.clsCFG.msg_log('AI model download failed: server[%s]--->remote ftp file[%s] do not exists!'%(self.host, remote_file_path))
                print('AI model download failed: server[%s]--->remote ftp file[%s] do not exists!'%(self.host, remote_file_path))

    # purpose: to upload the files from local device to sftp server
    def put_files(self, remote_file_path, local_file_path):
        with pysftp.Connection(self.host, username=self.uid, password=self.pwd, cnopts=self.cnopts) as sftp_handle:
            sftp_handle.cwd(remote_file_path)
            sftp_handle.put(local_file_path)

    # purpose: to remove/delete the files from sftp server
    def remove_files(self, remote_file_path):
        with pysftp.Connection(self.host, username=self.uid, password=self.pwd, cnopts=self.cnopts) as sftp_handle:
            if sftp_handle.exists(remote_file_path):
                sftp_handle.remove(remote_file_path)
            else:
                self.clsCFG.msg_log('ftp file remove failed: server[%s]--->remote ftp file[%s] do not exists!'%(self.host, remote_file_path))
                print('ftp file remove failed: server[%s]--->remote ftp file[%s] do not exists!'%(self.host, remote_file_path))